package com.example.asynctaskexample.app;

import android.os.AsyncTask;
import android.support.v7.app.ActionBarActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.ToggleButton;


public class MainActivity extends ActionBarActivity implements CompoundButton.OnCheckedChangeListener {

    private ToggleButton button;
    private DelayTask dTask;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        button=(ToggleButton)findViewById(R.id.toggleButton);
        dTask=new DelayTask();
        button.setOnCheckedChangeListener(this);
    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();
        if (id == R.id.action_settings) {
            return true;
        }
        return super.onOptionsItemSelected(item);
    }


    public void setActualTime(int time) {
        TextView text2=(TextView)findViewById(R.id.textView2);
        text2.setText("Current Time: "+time);
        if (time == 0)
               button.setChecked(false);
    }


    @Override
    public void onCheckedChanged(CompoundButton compoundButton, boolean b) {
        if (compoundButton == button) {
            if (compoundButton.isChecked()) {
                EditText etext=(EditText)findViewById(R.id.editText);
                int time=Integer.parseInt(etext.getText().toString());
                if (time > 0) {
                    Log.d("ASYNC", "START");
                    dTask.execute(time);
                }
            } else
                dTask.cancel(true);
        }
    }


    private class DelayTask extends AsyncTask<Integer, Integer, Void> {

        @Override
        protected Void doInBackground(Integer... parameters) {
            // Retrieve the starting time
           int time=parameters[0];
           Log.d("ASYNC", "EXECUTE "+time);
           while (time >0) {
               Log.d("ASYNC", "EXECUTE2");
               try {
                   Thread.sleep(1000);
               } catch (InterruptedException e) {
                   e.printStackTrace();
               }

               time--;
               publishProgress(time);
           }

            return null;
        }

        @Override
        protected void onProgressUpdate(Integer... values) {
            super.onProgressUpdate(values);
            setActualTime(values[0]);
        }
    }

}
