package it.android.cs222;

import it.android.cs222.LocalService.SimpleBinder;
import android.app.Activity;
import android.app.Service;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.ServiceConnection;
import android.os.Bundle;
import android.os.IBinder;
import android.text.format.DateFormat;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.widget.ToggleButton;

public class BoundServiceExampleActivity extends Activity {
    /** Called when the activity is first created. */
	private LocalService lService;
	private TextView text;
	private Button reqButton;
	private ToggleButton toggleButton;
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
    
        text=(TextView)findViewById(R.id.textView1);
        reqButton=(Button)findViewById(R.id.button1);
        toggleButton=(ToggleButton)findViewById(R.id.toggleButton1);
    }
    
    
    public void bindPressed(View w) {
    	if (toggleButton.isChecked()) {
    		
    		Intent intent=new Intent(this,LocalService.class);
    		bindService(intent,mConnection,Context.BIND_AUTO_CREATE);
    		
    	} else {
    		
    		reqButton.setEnabled(false);
    		text.setText("Service disconnected ...");
    		unbindService(mConnection);
    	}
    }
    
    
   public void requestPressed(View w) {
	   	String val= "Local Time: "+java.text.DateFormat.getDateTimeInstance().format(lService.getDate());
	   	text.setText(val);
	   
   }
    
    
    
    private ServiceConnection mConnection=new ServiceConnection() {

		@Override
		public void onServiceConnected(ComponentName arg0, IBinder bind) {
			SimpleBinder sBinder=(SimpleBinder) bind;
			lService=sBinder.getService();
			text.setText("Service connected ...");
			reqButton.setEnabled(true);
		}

		@Override
		public void onServiceDisconnected(ComponentName arg0) {
			
			
		}
    	
    };
}