package it.android.cs32;

import java.text.DecimalFormat;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.RadioGroup;
import android.widget.RadioGroup.OnCheckedChangeListener;
import android.widget.CompoundButton;
import android.widget.TextView;
import android.widget.ToggleButton;

public class SimpleThreadExampleActivity extends Activity implements OnClickListener {
    /** Called when the activity is first created. */
	private CounterThread workerThread;
	public Handler handler;
	private TextView text;
	private ToggleButton toggle;
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        text=(TextView)findViewById(R.id.textView1);
        toggle=(ToggleButton)findViewById(R.id.toggleButton1);
        final DecimalFormat df=new DecimalFormat("#.##");
        
        handler=new Handler() {
        	public void handleMessage(Message msg) {
        		double value=msg.getData().getDouble("time");
        		String label="Time: "+ df.format(value);
        		text.setText(label);
        		Log.d("THREAD",label);
        	}
        };
        
        
        toggle.setOnClickListener((OnClickListener) this);
    }
    
    
	@Override
	public void onClick(View arg0) {
		if (toggle.isChecked()) {
			workerThread=new CounterThread();
			workerThread.start();
		} else {
			workerThread.reset();
		}				
	}
    
    
    
    
    class CounterThread extends Thread {
    	
    	private boolean running;
    	private double timeValue;
    	
    	public CounterThread() {
    		super("CounterThread");
    		running=false;
    		timeValue=0.0;
    	}
    	
    	public void run() {
    		while(running) {
    			try{Thread.sleep(10);} catch (InterruptedException e){} 
    			timeValue+=0.01;
    			Message msg=handler.obtainMessage();
    			Bundle b=new Bundle();
    			b.putDouble("time", timeValue);
    			msg.setData(b);
    			handler.sendMessage(msg);
    			Log.d("THREAD","RUNNING");
    		}
    	}
    	
    	public void start() {
    		running=true;
    		super.start();
    	}
    	
    	
    	public void reset() {

            running=false;
    	}
    
    }






}